// Corpus35P2.pde
// 
// Gerard Paresys Guy Kayser
// 11 11 2014
// Processing 2.0.3
//
// Utilise la library minim incluse dans Processing 2
// http://code.compartmental.net/minim/
//
// Utilise la "contributed library" peasycam by Jonathan Feinberg
// http://mrfeinberg.com/peasycam/
//
// Voir: "Image to 3D mesh" de frankie zafe
// http://www.openprocessing.org/sketch/100339
//
// Si le dossier data contient 5 fichiers nommés:
//   XXX.xml  (format Praat TextGrid sauve en UTF8)
//   XXX.mp3
//   XXX_Pitch.txt
//   XXX_Intensity.txt
//   XXX.png
// le sketch les ouvre
// sinon un selecteur de fichiers s'ouvre, choisir alors un fichier XXX.xml...
//
// Modifier la ligne 54 au besoin
//
// Le dossier data doit contenir aussi:
//   AdventPro-Thin.ttf, interface9.jpg
//
// Touche S         Sauve l'ecran (format png)
// Touche Espace    Pause 
// Touche M         Maillage
// Touche B         Dessin base
// Touche Z         Mouvement
// Touche A         Aligne Gauche / Centre
// Touche H         Horizontal / Vertical
// Touche L         Lumiere
// Touche T         Affiche temps en bas a droite
// Touche D         Debut
// Touche F         Face (facette)
// Clic souris dans la fenêtre d'abord  
// PeasyCam: Souris Molette           : Zoom
//           Souris Clic droit + Drag : Zoom      
//           Souris Clic + Drag       : Rotation      
//           Souris 2 x Clic          : Reset position
//           Souris cmd + Clic + Drag : Translate (MacOS)
//  

import ddf.minim.*;         // pour AudioPlayer
import peasy.*;

PeasyCam pcam;
String  NomFichierXML = "reunionn.xml"; // les 5 fichiers "reunion..." doivent etre dans le dossier data
// sinon le selecteur de fichier s'ouvre      
color   CouleurBackground = color(0); // 
color   CouleurShape      = color(255, 100);    // 
color   CouleurTexteTranscription  = color(255);    // Blanc
color   CouleurTexteTraduction     = color(255, 0, 0);    // Rouge
color   CouleurFil        = color(200);    
boolean Verbose           = false;
boolean Base              = true; // false
boolean Maille            = false; // true      
boolean Mouvement         = false; // true      
boolean AlignGauche       = false;
boolean Horizontal        = true;
boolean Lumiere           = true;
int     DecalHorizontal   = 0;
int     DecalVertical     = 0;

PFont  maFonte;
String NomFichierAudio     = "XXX.mp3";
String NomFichierPitch     = "XXX_Pitch.txt";
String NomFichierIntensity = "XXX_Intensity.txt";
String NomFichierCarte     = "XXX.png";
float  FacteurX            = 32;
float  Facteur;
float  Echelle             = 1;

int Couche = 0;  //Traduction
// int Couche = 1;  //Transcription
boolean DessinCurveVertex = false; 
boolean DessinCaractere = false; 
int     Blur = 60;               // 255: normal pas de blur   0: Blur max    Essayer 100
boolean AfficheT = false;        // Chrono en bas a droite
boolean DessinPitch = false;     // 
boolean DessinIntensity = true;  // 

int xCount;  

int yCount; // yCount = (NombreSegment+1)/2 +1
int offsetX = 0, offsetY = 0;
int[][] Tableau, Tableau2;

String[] list, LignesPitch;
String[] LignesIntensity;
int IndexPitch = 0;
int IndexCaracterePitch = 0;
int IndexIntensity = 0;
int IndexCaractereIntensity = 0;
float xAvantPitch, xApresPitch, yAvantPitch, yApresPitch;
float xAvantIntensity, xApresIntensity, yAvantIntensity, yApresIntensity;
int LigneText, x;
AudioPlayer player;
Minim minim;
float temps, DureeFichier;
boolean Probleme = false, Fin = false, FichierOuvert = false;
boolean ToucheEspace = false, Pause = false, Trace = false, DebutTrace = false;
float[] LignePitch, LigneIntensity;
float TempsPause = 0, TempsDebutPause = 0;
XML xml1, kid1, kid2;
XML[] kid1Data, kidkid1Data, kidkid1intervals, kidkid1intervalsxmax;
XML[] Traduction, Transcription;
int NombreDeChild2, NombreSegment;
int IndexXML = 0, Segment;
float xmin, xmax;  // Temps en seconde
String s1, s2, Content1 = "", Content2 = "", Content = "";
char Caractere;
int ValueMouseDragged =0;
int x1, y1, z1, x2, y2, z2, zTexte;
int TailleX = 612, TailleY = 612;
int PositionX = 0, PositionY = 0; // 0 0 = centre de la fenetre
int Alea; //

float xgrid, ygrid;
PImage ImageTexture, ImageBackground;

PImage levels;

Mappoint[] mappoints;
Mapface[] mapfaces;
int mapwidth;
int mapheight;


MapTraveller[] mtrav;
int travnum = 1; //nombre de fil
// int travhisto = int(random(550, 1000));//longueur du fil
int travhisto =  500; //longueur du fil
//int travhisto = int(250); //longueur du fil

// int vectorrange = 10;
float sampling = 10;  // taille de la maille de la carte
float elevation = 80; // hauteur maxi

boolean showimage = false;
boolean drawfaces = true; 


void setup() {
  size(1024, 768, P3D); 
  ImageBackground = loadImage("interface9.jpg");
  background(ImageBackground);

  //pcam = new PeasyCam(this, 0, 0, 0,1000);
  pcam = new PeasyCam(this, 512, 384, 0, 800);
  pcam.setMinimumDistance(40);
  pcam.setMaximumDistance(3000);

  maFonte = createFont("AdventPro-Thin", 18);

  File Fichier = new File(dataPath(NomFichierXML));
  if (Fichier.exists()) Ouverture(NomFichierXML);
  else selectInput("select the XML File (format Praat textGrid):", "fileSelected");
}

void draw() {
  if (Lumiere) lights();

  if (! Pause) {
    temps = millis() - TempsPause; //temps en ms
    if ((! Fin) && AfficheT) AfficheTemps(temps);
    temps = temps / 1000; // temps en sec
  }

  if (FichierOuvert) {
    background(CouleurBackground);   

    if (! Pause) for (int i=0; i < mtrav.length; i++ ) mtrav[i].update(); // Si pas en pause, le fil avance
    // println("mtrav.length = " + mtrav.length);
    if (showimage) image( levels, 0, 0 );
    noFill();
    int p = 0;

    if ( drawfaces ) {
      for ( int i=0; i < mapfaces.length; i++ ) {
        Mapface face = mapfaces[ i ];
        noStroke();
        // fill( 255 * face.center.z / elevation );
        // beginShape();
        beginShape(TRIANGLE_STRIP); // consomme beaucoup - de CPU que beginShape()
        fill( 255 * face.center.z / elevation );
        p = 0;
        vertex( face.pts[p].position.x, face.pts[p].position.y, face.pts[p].position.z );
        p++;
        vertex( face.pts[p].position.x, face.pts[p].position.y, face.pts[p].position.z );
        p++;
        vertex( face.pts[p].position.x, face.pts[p].position.y, face.pts[p].position.z );
        endShape( CLOSE );
      }
    }; 

    if ( Maille ) {
      stroke( 250, 50 );
      strokeWeight( 1 );
      for ( int r=0; r < mapheight-1; r++ ) {
        for ( int c=0; c < mapwidth-1; c++ ) {
          p = c + r * mapwidth;
          line( 
          mappoints[ p ].position.x, mappoints[ p ].position.y, mappoints[ p ].position.z, 
          mappoints[ p+1 ].position.x, mappoints[ p+1 ].position.y, mappoints[ p+1 ].position.z
            );
          line( 
          mappoints[ p ].position.x, mappoints[ p ].position.y, mappoints[ p ].position.z, 
          mappoints[ p+mapwidth ].position.x, mappoints[ p+mapwidth ].position.y, mappoints[ p+mapwidth ].position.z
            );
          if ( c == mapwidth-2 ) {
            line( 
            mappoints[ p+1 ].position.x, mappoints[ p+1 ].position.y, mappoints[ p+1 ].position.z, 
            mappoints[ p+mapwidth+1 ].position.x, mappoints[ p+mapwidth+1 ].position.y, mappoints[ p+mapwidth+1 ].position.z
              );
          }
          if ( r == mapheight-2 ) {
            line( 
            mappoints[ p+mapwidth ].position.x, mappoints[ p+mapwidth ].position.y, mappoints[ p+mapwidth ].position.z, 
            mappoints[ p+mapwidth+1 ].position.x, mappoints[ p+mapwidth+1 ].position.y, mappoints[ p+mapwidth+1 ].position.z
              );
          }
        }
      }
    }

    // Le dessin du fil 
    strokeWeight( 1 );
    // stroke( CouleurFil );
    // println("mtrav[0].positions.length = " + mtrav[0].positions.length);
    for ( int i=0; i < mtrav.length; i++ ) {
      for ( int j=1; j < mtrav[i].positions.length; j++ ) {
        stroke( 255, 255 - (j / (travhisto / 250))); // le fil devient progressivement transparent
        // strokeWeight(random( 5 )); // 
        line(
        mtrav[i].positions[ j-1 ][ 0 ], 
        mtrav[i].positions[ j-1 ][ 1 ], 
        mtrav[i].positions[ j-1 ][ 2 ], 
        mtrav[i].positions[ j ][ 0 ], 
        mtrav[i].positions[ j ][ 1 ], 
        mtrav[i].positions[ j ][ 2 ] );
      }
    }  

    if (IndexXML < (NombreSegment-1)) {
      if (temps > xmax) {                        // Passage au segment suivant
        IndexXML = IndexXML + 1;
        Content = Traduction[IndexXML].getContent();
        Content2 = Transcription[IndexXML].getContent();

        if (Verbose) println();
        if (Verbose) println("IndexXML = " + IndexXML);

        if (Content == null) IndexXML = IndexXML + 1;
        else if (Content.equals("_") == true) IndexXML = IndexXML + 1;//Elimination des caracteres _ qui separe les segments
        // else if ((temps > xmin) && ! Pause) {
        else if (! Pause) {
          Segment = Traduction[IndexXML].getInt("n"); 
          xmin = Traduction[IndexXML].getFloat("xmin");
          xmax = Traduction[IndexXML].getFloat("xmax");


          IndexCaracterePitch = 0;
          IndexCaractereIntensity = 0;   

          Content1 = trim(Content);
          Content2 = trim(Content2);
        }
      }
    }
    else Pause = true;

    textFont(maFonte);  
    fill(255, 0, 0); // Texte rouge
    text(Content1, 512, YIntensity(40) + 200, 100 ); // Traduction

    if (true) {
      for (int y = -yCount; y < yCount; y++) {
        // for (int y = -yCount; y < n-yCount; y++) {
        // beginShape(QUAD_STRIP);
        beginShape(TRIANGLE_STRIP);
        // strokeWeight(1);
        fill(CouleurShape);         
        // texture(ImageTexture);
        if (Maille) {
          stroke( 255, 45);
          strokeWeight( 1 );
        }
        else noStroke();
        // noFill();
        // Alea = int(random(5));
        // for (int x = - xCount; x <= xCount; x++) {
        for (int x = - xCount + 1; x < xCount; x++) {
          if (y > -yCount) {
            z1 = Tableau[x + xCount][y - 1 + yCount]-5; // - 5 pour enfoncer la voix
            z2 = Tableau[x + xCount][y     + yCount]-5; // - 5 pour enfoncer la voix
            // if ((z1 > Tableau2[x + xCount][y - 1 + yCount]) || (z2 > Tableau2[x + xCount][y + yCount])) {
            if ((Tableau[x + xCount + 1][y - 1 + yCount] > Tableau2[x + xCount + 1][y - 1 + yCount]) || 
              (Tableau[x + xCount + 1][y + yCount] > Tableau2[x + xCount + 1][y + yCount]) || 
              (Tableau[x + xCount - 1][y - 1 + yCount] > Tableau2[x + xCount - 1][y - 1 + yCount]) ||
              (Tableau[x + xCount - 1][y + yCount] > Tableau2[x + xCount - 1][y + yCount]) || !Base) {
              // if ((x + xCount + 1) == Segment) zTexte = z2;
              if (Mouvement) x1 = int(TailleX / (2 * xCount) * x * zTexte / 100)     + PositionX+(width/2);
              else x1 = int(TailleX / (2 * xCount) * x)     + PositionX+(width/2) ;
              // x1 = int(TailleX / (2 * xCount) * x)     + PositionX ;   OUI
              // x1 = int(TailleX / (2 * xCount) * x * x * x / 1000)     + PositionX ; 

              y1 = int(TailleY / (2 * yCount) * (y-1)) + PositionY + (height/2) ; 
              y2 = int(TailleY / (2 * yCount) * (y))   + PositionY + (height/2) ; 
              if (Horizontal) {
                vertex(x1, y1, z1);//positiontranscription
                vertex(x1, y2, z2);
                //  vertex(x1, y1, z1, random(100), random(100));
                //  vertex(x1, y2, z2, random(100), random(100));
                //  vertex(x1, y1, z1, 0, 50);
                //  vertex(x1, y2, z2, 50, 0);
              }
              else {
                vertex(y1, x1, z1);
                vertex(y2, x1, z2);
              }
            }
          }
        }
        endShape();
      }
      fill(255); // Texte noir
      // text(Content2, 10, YIntensity(40) + 5, width-20, 50 ); // Transcription
      // text(Content2, -250, YIntensity(270) + 5 , 80); // Transcription
      // text(Content2, 0, 0, 0); // Transcription
      textAlign(CENTER);

      // text(Content2, -250, n * 30 - 200, 80); // Transcription
      y1 = int(TailleY / (2 * yCount) * (Segment-yCount)) + PositionY + (height/2);
      // z2 = Tableau[x + xCount][Segment    + yCount];
      // text(Content2,0, y1, 80); // Transcription
      text(Content2, PositionX + (width/2), y1, zTexte + 0); // Transcription
    }
    // println("xgrid = " + xgrid);
    // println("ygrid = " + ygrid);


    // Dans cette version l'axe horizontal de la ligne de pitch =Duree du segment
    // et le dessin est fait avec:  beginShape();  vertex(x, y);  ou curvevertex(x, y); endShape(); au choix

    if (DessinPitch) {
      if (IndexPitch < LignesPitch.length) {
        LignePitch = float(split(LignesPitch[IndexPitch], "   "));
        if (Float.isNaN(LignePitch[0])) IndexPitch = IndexPitch + 1;
        if ((temps > LignePitch[0]) && ! Pause) {
          if (Float.isNaN(LignePitch[1])) IndexPitch = IndexPitch + 1;
          else {
            if (Trace) {
              if (IndexCaracterePitch < Content1.length()) {
                textFont(maFonte, 14);
                Caractere = Content1.charAt(IndexCaracterePitch);
                xApresPitch = int(((LignePitch[0] - xmin) / (xmax - xmin)) * float(width));
                // yApresPitch = YPitch(LignePitch[1]) ;
                yApresPitch = YPitch(LignePitch[1] + 120) ;
                println("LignePitch[0] = " + LignePitch[0] + "      xApresPitch = " + xApresPitch + "    yApresPitch = " + yApresPitch );
                if (DebutTrace) {
                  println("Debuttrace n = " + Segment);
                  beginShape(); // 
                  if (DessinCurveVertex) curveVertex(xApresPitch, yApresPitch);
                  else vertex(xApresPitch, yApresPitch, 0);
                  xAvantPitch = xApresPitch;    
                  yAvantPitch = yApresPitch;
                  DebutTrace = false;
                }

                if (DessinCurveVertex) curveVertex(xApresPitch, yApresPitch);
                else vertex(xApresPitch, yApresPitch, 0);

                smooth();
                stroke(150);      // Couleur des lignes  0=noir 255=blanc
                strokeWeight(1); // Epaisseur des lignes
                noFill();
                line(xAvantPitch, yAvantPitch, xApresPitch, yApresPitch);

                if (DessinCaractere) {
                  fill(0, 0, 0); // Texte noir
                  translate(xApresPitch, yApresPitch);
                  rotate(atan2((yApresPitch - yAvantPitch), textWidth(Caractere)));
                  text(Caractere, 0, 0);
                  rotate(atan2(-(yApresPitch - yAvantPitch), textWidth(Caractere)));
                } 
                xAvantPitch = xApresPitch;    
                yAvantPitch = yApresPitch;
                IndexCaracterePitch = IndexCaracterePitch +1;
              }
            }
            Trace = true;
            IndexPitch = IndexPitch + 1;
          }
        }
      } 
      else Fin = true;
    }

    // if (DessinIntensity) {
    if (false) {
      if (IndexIntensity < LignesIntensity.length) {
        LigneIntensity = float(split(LignesIntensity[IndexIntensity], "   "));
        if (Float.isNaN(LigneIntensity[0])) IndexIntensity = IndexIntensity + 1;
        if ((temps > LigneIntensity[0]) && ! Pause) {
          if (Float.isNaN(LigneIntensity[1])) IndexIntensity = IndexIntensity + 1;
          else {
            // if (Trace) {
            xApresIntensity = int(((LigneIntensity[0] - xmin) / (xmax - xmin)) * float(xCount * 2));
            if ((xApresIntensity < (2 * xCount + 1)) && (xApresIntensity > 0) && (Segment < (2 * yCount + 1))) {
              //                  Tableau[int(xApresIntensity)][n] = int(yApresIntensity);     
              //                  Tableau[int(xApresIntensity)][n] = int(LigneIntensity[1]);     
              Tableau[int(xApresIntensity)][Segment] = int((LigneIntensity[1] - 30)*2.0);     
              // Tableau[int(xApresIntensity)][n] = n;
              println("Tableau[int(xApresIntensity)][Segment] = " + Tableau[int(xApresIntensity)][Segment]);
            }
            // println("xApresIntensity = " + xApresIntensity + "      n = " + n + "    LigneIntensity[1] = " + LigneIntensity[1] );

            Trace = true;
            // IndexIntensity = IndexIntensity + 5;
            IndexIntensity = IndexIntensity + 3;
          }
        }
      } 
      else Fin = true;
    }

    if (DessinIntensity) {
      // La derniere ligne du fichier XXX_Intensity.txt
      // LigneIntensity = float(split(LignesIntensity[LignesIntensity.length - 1], "   "));
      // float[] Fff = float(split(LignesIntensity[LignesIntensity.length - 1], "   "));
      //println("Fff[0] = " + Fff[0] + "     Fff[1] = " + Fff[1]);
      // xApresIntensity = int(((temps - xmin) / (xmax - xmin)) * float(xCount * 2));

      if (AlignGauche) xApresIntensity = int(((temps - xmin) / (12)) * float(xCount * 2));
      else xApresIntensity = int(((temps - xmin - (xmax-xmin)/2) / (12)) * float(xCount * 2)) + 30;

      //println("xApresIntensity = " + xApresIntensity);
      // noiseDetail(4, 0.001);
      if ((xApresIntensity < (2 * xCount + 1)) && (xApresIntensity > 0) && (Segment < (2 * yCount + 1))) {
        // int Facteur = int(temps * 100.0);
        // int Facteur = int(temps * Fff[0] / Fff[1]);
        // int Facteur = int(temps * LignesIntensity.length / Fff[0]);
        int Ligne = int(temps * Facteur);
        if (Verbose) println("Facteur = " + Facteur);
        if (Verbose) println("Ligne = " + Ligne);
        if (Ligne < LignesIntensity.length) {
          LigneIntensity = float(split(LignesIntensity[Ligne], "   "));
          // Tableau[int(xApresIntensity)][n] = int((LigneIntensity[1] - 30.0) * 2.0);     
          // Tableau[int(xApresIntensity)][n] = int((LigneIntensity[1] - 20.0) * 2.0);     
          // Tableau[int(xApresIntensity)][n] = Tableau2[int(xApresIntensity)][n] + int((LigneIntensity[1] - 20.0) * 2.0);     
          Tableau[int(xApresIntensity)][Segment] = Tableau2[int(xApresIntensity)][Segment] + int((LigneIntensity[1] - 20.0) * 1.0);
          // Tableau[int(xApresIntensity)][Segment] = Tableau2[int(xApresIntensity)][Segment] + int(100 * noise(xApresIntensity, Segment));
          zTexte = Tableau[int(xApresIntensity)][Segment];
          if (Verbose) println("Tableau[" + int(xApresIntensity) + "][" + Segment + "] = " + Tableau[int(xApresIntensity)][Segment]);
        }
      }
    }
  }
}

float YPitch(float w) { // w en Hz  YPitch en pixel
  return ((500 - w) / 2) + 100;
  //return ((500 - w) / 2) + 10;
}

float YIntensity(float w) {
  if (w < 40) w= 40;
  return ((100 - w) * 3) + 312;
}

void AfficheTemps(float T) {
  // T = T / 1000;
  T = int(T / 100);
  T = T / 10;
  x = width - 72;
  //  fill(0);
  //  rect(x - 3, 587, 100, 15);
  fill(0);
  textFont(maFonte, 12);
  text(T + " sec", x, height - 3);
}


void EffaceEcran() {
  xAvantPitch = 0;
  yAvantPitch = YPitch(75) ;
  xAvantIntensity = 0;
  yAvantIntensity = YIntensity(40) ;
}


private void processMap( int[] pixels, int imgwidth, int imgheight ) {

  float[] pixels_brightness = new float[ pixels.length ];
  for ( int p=0; p < pixels.length; p++ )
    pixels_brightness[ p ] = brightness( pixels[ p ] ) / 255.f;

  // creating the map points
  mapwidth  = (int) ceil(imgwidth  / sampling);
  mapheight = (int) ceil(imgheight / sampling);
  println("imgwidth = " + imgwidth); // imgwidth = 1024
  println("imgheight = " + imgheight); // imgheight = 768
  int i = 0;
  int gc = 0;
  int gr = 0;
  for ( int r=0; r < imgheight; r += sampling ) {
    gc = 0;
    for ( int c=0; c < imgwidth; c += sampling ) {
      int pix = c + ( r * imgwidth );
      // if sampling si > 1, than we average the surrounding pixels
      int np = 0;
      float totalb = 0;
      int halfs = (int) floor( sampling * 0.5f );
      for ( int sy = r-halfs; sy <= r+halfs; sy++ ) {
        if ( sy < 0 )
          continue;
        if ( sy >= imgheight )
          break;
        for ( int sx = c-halfs; sx <= c+halfs; sx++ ) {
          if ( sx < 0 )
            continue;
          if ( sx >= imgwidth )
            break;
          totalb += pixels_brightness[ sx + ( sy * imgwidth ) ];
          np++;
        }
      }
      totalb /= np;
      mappoints[ i ] = new Mappoint( i, gc, gr );
      mappoints[ i ].position.set( ( c + 0.5f ), ( r + 0.5f ), totalb * elevation );
      i++;
      gc++;
    }
    gr++;
  }

  // creating map faces
  mapfaces = new Mapface[ (mapwidth - 1) * (mapheight - 1) * 2 ];
  println("mapfaces.length = " + mapfaces.length); // mapfaces.length = 15504
  println("mapwidth = " + mapwidth); // mapwidth = 103
  println("mapheight = " + mapheight); // mapheight = 77
  int facescount = 0;
  i = 0;
  for ( int r=1; r < mapheight; r++ ) {
    for ( int c=0; c < mapwidth-1; c++ ) {
      i = c + r * mapwidth;
      Mappoint topleft = mappoints[ i - mapwidth ];
      Mappoint topright = mappoints[ i - mapwidth + 1 ];
      Mappoint bottomleft = mappoints[ i ];
      Mappoint bottomright = mappoints[ i +1 ];
      mapfaces[ facescount ] = new Mapface( topleft, topright, bottomright );
      facescount++;
      mapfaces[ facescount ] = new Mapface( topleft, bottomright, bottomleft );
      facescount++;
    }
  }
}


void Debut() {
  IndexPitch = 0;
  IndexIntensity = 0;
  IndexXML = -1;
  EffaceEcran();
  EffaceTableau();
  xmax = 0;
  TempsPause = millis();
  PlayerAudioDebut();
}


void PlayerAudioDebut() {
  player.close();
  player = minim.loadFile(NomFichierAudio, 2048);
  player.play();
}


void keyPressed() {
  // println("key = " + key);
  if (key == ' ') {         // barre d'espace
    ToucheEspace = ! ToucheEspace;
    Pause = ToucheEspace;
    if (Pause) {
      player.pause();
      TempsDebutPause = millis();
    }
    else {
      player.play();
      TempsPause = TempsPause + millis() - TempsDebutPause;
    }
  }
  else  if ( key == 'p' || key == 'P' ) {
    Couche = 0; // P Phonème
    Debut();
  }
  else if (key == 'y' || key == 'Y') {
    Couche = 1; // Y Syllabe
    Debut();
  }
  else if (key == 'b' || key == 'B') Base = !Base;               // Touche B        Dessin base
  else if (key == 'm' || key == 'M') Maille = !Maille;           // Touche M        Maillage
  else if (key == 'z' || key == 'Z') Mouvement = !Mouvement;     // Touche Z        Mouvement
  else if (key == 'a' || key == 'A') AlignGauche = !AlignGauche; // Touche A        Aligne Gauche / Centre
  else if (key == 'h' || key == 'H') Horizontal = !Horizontal;   // Touche H        Horizontal / Vertical
  else if (key == 'l' || key == 'L') Lumiere = !Lumiere;         // Touche L        Lumiere
  else if (key == 'f' || key == 'F') {                           // Touche F        Face (facette)
    drawfaces = !drawfaces;
    showimage = !showimage;
  }
  else if (key == 'o' || key == 'O') {
    Couche = 4; // O Orthographique
    Debut();
  }
  else if (key == 's' || key == 'S') saveFrame("Screen" + frameCount + ".png");
  else if (key == 't' || key == 'T') AfficheT = !AfficheT;     // Touche T        Affiche temps en bas a droite
  else if (key == 'd' || key == 'D') Debut();                  // Touche D        Debut
  else if (keyPressed && (key == CODED)) { // If it's a coded key
    if (keyCode == LEFT) {            // Left arrow
      FacteurX = FacteurX / 2;
      Debut();
    } 
    else if (keyCode == RIGHT) {      // Right arrow
      FacteurX = FacteurX * 2;
      Debut();
    }
  }
}


void fileSelected(File FichierChoisi) {
  if (FichierChoisi == null) {
    println("Pas de fichier XXX.xml ouvert!");
    exit();
  } 
  else Ouverture(FichierChoisi.getAbsolutePath());
}

void Ouverture(String NomFichier) {
  // println("NomFichierXML = " + NomFichier);
  Probleme = false;

  File Fichier = new File(dataPath(NomFichier));
  if (!Fichier.exists()) { 
    println("Le fichier " + NomFichier + " n'existe pas");
    Probleme = true;
  }

  if (!Probleme) {
    list = split(NomFichier, '.');
    NomFichierXML = list[0] + ".xml";
    if (loadStrings(NomFichierXML) == null) { 
      println("Le fichier " + NomFichierXML + " n'existe pas");
      Probleme = true;
    }
  }

  if (!Probleme) {
    // xml1 = new XMLElement(this, NomFichierXML);
    xml1 = loadXML(NomFichierXML);  //Processing 2.0
    println("Ouverture de: " + NomFichierXML);
    if (Verbose) println("1-----------------------------------------------------------");
    // NombreDeChild1 = xml1.getChildCount();
    if (xml1.hasChildren()) { 
      //  println("xml1.hasChildren");
      if (Verbose) println("xml1.listChildren() : ");
      if (Verbose) println(xml1.listChildren());
    } 
    else {
      println("Le fichier xml n'a pas le bon format");      
      Probleme = true;
    }
  }

  if (!Probleme) {
    if (!(xml1.listChildren()[1] == "items" )) {
      println("Le fichier xml n'a pas le bon format");
      Probleme = true;
    }
  }

  if (!Probleme) {
    kid1Data = xml1.getChildren("items");
    //    println("2-----------------------------------------------------------");
    //    println(kid1Data);
    kidkid1Data = kid1Data[0].getChildren("item");
    //      s2 = kidkid1Data[1].getName();
    //      println("s2 = " + s2);
    if (Verbose) println("kidkid1Data-----------------------------------------------------------");
    // println(kidkid1Data);  // gros a lister
    if (Verbose) println("-----------------------------------------------------------");
    if (Verbose) println("Length of kidkid1Data = " + kidkid1Data.length);
    if (Verbose) println("kidkid1Data[0].getName() = " + kidkid1Data[0].getName());
    if (Verbose) println("kidkid1Data[1].getName() = " + kidkid1Data[1].getName());
    if (Verbose) println("kidkid1Data[0].listAttributes() = " + kidkid1Data[1].getChildren("item"));

    //    kidkid1intervals = kidkid1Data[4].getChildren("intervals");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println(kidkid1intervals);
    //    println("-----------------------------------------------------------");
    //    println("Length of kidkid1intervals = " + kidkid1intervals.length);
    //    println("kidkid1intervals[10].getName() = " + kidkid1intervals[10].getName());
    //    println("kidkid1intervals[11].getName() = " + kidkid1intervals[11].getName());
    //    println("kidkid1intervals.listAttributes() = " + kidkid1intervals[10].getChildren("intervals"));
    //
    //    // kidkid1intervalsxmax = kidkid1intervals[76].getChildren("xmax");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println("kidkid1intervals[26].getInt(\"n\")      = " + kidkid1intervals[26].getInt("n"));
    //    println("kidkid1intervals[26].getFloat(\"xmax\") = " + kidkid1intervals[26].getFloat("xmax"));
    //    println("kidkid1intervals[26].getFloat(\"xmin\") = " + kidkid1intervals[26].getFloat("xmin"));
    //    println("kidkid1intervals[26].getContent()     = " + kidkid1intervals[26].getContent());
    //    println();
    //    println("kidkid1intervals[27].getFloat(\"xmax\") = " + kidkid1intervals[27].getFloat("xmax"));
    //    println("-----------------------------------------------------------");
    //      println("Length of kidkid1intervalsxmax = " + kidkid1intervalsxmax.length);
    //      println("kidkid1intervalsxmax[10].getName() = " + kidkid1intervalsxmax[10].getName());
    //      println("kidkid1intervalsxmax[11].getName() = " + kidkid1intervalsxmax[11].getName());
    //      println("kidkid1intervalsxmax.listAttributes() = " + kidkid1intervalsxmax[10].getChildren("intervals"));
    //    fill(0);
    //    textFont(maFonte, 16);
    //    fill(180);
    //    textFont(maFonte, 12);
    //    text(NomFichierXML, 10, 65);

    Traduction = kidkid1Data[0].getChildren("intervals");
    NombreSegment = Traduction.length;
    if (Verbose) println("oooooooooooooooooooooooooooooooooooooooooooooo");
    // println(Traduction);  // gros a lister
    if (Verbose) println("oooooooooooooooooooooooooooooooooooooooooooooo");

    Transcription = kidkid1Data[1].getChildren("intervals");
    if (NombreSegment != Transcription.length ) {
      println("Le fichier xml n'a pas le bon format");
      println("il n'y a pas le meme nombre de segment transcrit et traduit");
      Probleme = true;
    }
  } 

  if (! Probleme) { 
    NomFichierPitch = list[0] + "_Pitch.txt";
    if (loadStrings(NomFichierPitch) == null) { 
      println("Le fichier " + NomFichierPitch + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesPitch = loadStrings(NomFichierPitch);
      println("Ouverture de: " + NomFichierPitch +"  " + LignesPitch.length + " lignes" );
    }
  } 

  if (! Probleme) { 
    NomFichierIntensity = list[0] + "_Intensity.txt";
    if (loadStrings(NomFichierIntensity) == null) { 
      println("Le fichier " + NomFichierIntensity + " n'existe pas");
      Probleme = true;
    } 
    else {
      LignesIntensity = loadStrings(NomFichierIntensity);
      println("Ouverture de: " + NomFichierIntensity +"  " + LignesIntensity.length + " lignes" );
    }
  } 

  if (! Probleme) { 
    NomFichierAudio = list[0] + ".mp3";
    if (loadStrings(NomFichierAudio) == null) { 
      println("Le fichier " + NomFichierAudio + " n'existe pas");
      Probleme = true;
    } 
    else println("Ouverture de: " + NomFichierAudio);
  }

  if (! Probleme) { 
    NomFichierCarte = list[0] + ".png";
    if (loadStrings(NomFichierCarte) == null) { 
      println("Le fichier " + NomFichierCarte + " n'existe pas");
      Probleme = true;
    } 
    else println("Ouverture de: " + NomFichierCarte);
  }

  if (! Probleme) { 
    println("NombreSegment = " + NombreSegment); 
    minim = new Minim(this);
    player = minim.loadFile(NomFichierAudio, 2048);

    LignePitch = float(split(LignesPitch[LignesPitch.length - 1 ], "   "));
    DureeFichier = LignePitch[0];
    if (Verbose) println("Duree " + NomFichierPitch + " = " + DureeFichier + " sec");

    LigneIntensity = float(split(LignesIntensity[LignesIntensity.length - 1 ], "   "));
    DureeFichier = LigneIntensity[0];
    if (Verbose) println("Duree " + NomFichierIntensity + " = " + DureeFichier + " sec");

    // float[] Fff = float(split(LignesIntensity[LignesIntensity.length - 1], "   "));
    // int Facteur = int(temps * LignesIntensity.length / Fff[0]);
    Facteur = LignesIntensity.length / LigneIntensity[0]; //Nombre de lignes / Duree totale fichier XXX_Intensity.txt 

    levels = loadImage(NomFichierCarte); // "reunion_couleur.png"
    mappoints = new Mappoint[ ceil( levels.width / sampling ) * ceil( levels.height / sampling ) ];
    levels.loadPixels();
    processMap( levels.pixels, levels.width, levels.height );
    //    println("levels.pixels = " + levels.pixels);
    //    println("levels.width = " + levels.width);
    //    println("levels.height = " + levels.height);
    mtrav = new MapTraveller[ travnum ];
    for ( int i=0; i < mtrav.length; i++ )
      mtrav[i] = new MapTraveller( random( 0.3f * levels.width, 0.7f * levels.height ), random( 0.3f * levels.width, 0.7f * levels.height ), 1.f, travhisto );


    player.play();
    TempsPause = millis();
    FichierOuvert = true;
    xmax = 0;
    IndexXML = -1;

    yCount = (NombreSegment+1)/2 +1;
    xCount = 30;

    // int[][] Tableau = new int[2 * xCount + 1][2 * yCount + 1];
    Tableau = new int[2 * xCount + 1][2 * yCount + 1];
    Tableau2 = new int[2 * xCount + 1][2 * yCount + 1];
    // int[][] Tableau;
    EffaceTableau();

    println("xCount = " + xCount);
    println("yCount = " + yCount);
  }
  else {
    exit();
  }
}

void EffaceTableau() {
  for (int y = -yCount; y < yCount; y++) {
    for (int x = - xCount; x <= xCount; x++) {
      // Tableau[x + xCount][y + yCount] = -abs(int(3 * x ));
      // Tableau[x + xCount][y + yCount]  = int(2 * sqrt((xCount * xCount) - (x * x * 0.95)));
      // Tableau2[x + xCount][y + yCount] = int(2 * sqrt((xCount * xCount) - (x * x * 0.95)));
      // Tableau[x + xCount][y + yCount]  = int(50 * (cos(radians(x*5))+1));
      // Tableau2[x + xCount][y + yCount] = int(50 * (cos(radians(x*5))+1));
      Tableau[x + xCount][y + yCount]  = 0;
      Tableau2[x + xCount][y + yCount] = 0;
      //      if ((x > -xCount / 2) && (x < xCount / 2)) {
      //        Tableau[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x * x)));
      //        Tableau2[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x * x)));
      //      }
      //      if ((x > xCount / 2)) {
      //        Tableau[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x - xCount / 2) * (x - xCount / 2)));
      //        Tableau2[x + xCount][y + yCount] = int(6 * sqrt((xCount * xCount / 4) - (x - xCount / 2) * (x - xCount / 2)));
      //      }
    }
  }
  // Tableau[10][10] = 10;
}

void stop() {
  // always close Minim audio classes when you are done with them
  player.close();
  minim.stop();
  super.stop();
}

